Attribute VB_Name = "M_VirtualList_API_Declares"
  Option Explicit
  ' demo project showing how to change styles of a VB listview to
  ' create a fully "vurtual list".  a virtual list is a list that
  ' is displayed by a control but the control itself doesn't contian
  ' or "store" the actual list items.  in other words, each time the
  ' control needs to draw an item, it raises an event to get the text
  ' that it needs to draw.  because the control doesn't need to have
  ' each item loaded "into" it, it can display large numbers of items
  ' blindingly fast.  Parts of this project are based on the code
  ' from the blackbelt article by Matt Hart found in the July, 1999
  ' issue of the VBPJ.  Any and all copyrights of the concept and
  ' code presented by Mr. Hart are still in effect and this demo
  ' makes no claim to the contrary.  this extension of Mr. Hart's
  ' concept is provided by Bryan Stafford of New Vision Software -
  ' newvision@mvps.org this demo is released "as is" without
  ' warranty or guaranty of any kind.  In other words, use at your
  ' own risk.
  '
  ' IMPORTANT NOTE:  this demo uses the 'Dbgwproc.dll' from the MS
  ' VB owner's area to allow breaking while running in the VB IDE.
  ' Although you can run this project without using the debug object,
  ' it is STRONGLY recommended that you use it due to the high
  ' potential for crashing the VB IDE without it.  If you choose to
  ' run this project without the debug object, set the Conditional
  ' Compilation Argument 'DEBUGWINDOWPROC' equal to zero on the Make
  ' tab of the Project Properties dialog.  You will also need to
  ' remove the reference to 'Debug Object for AddressOf Subclassing'
  ' in the references dialog.  !!BE WARNED!! If YOU RUN THIS PROJECT
  ' WITHOUT THE DEBUG OBJECT, YOU WILL MOST LIKELY CRASH YOUR
  ' INSTANCE OF VB!!
  '
  '
  ' ALSO NOTE:  this is a minimal implementation of a virtual
  ' listview.  because all of the items are virtual, the internal
  ' listitems collection of the listview is not used.  this means
  ' most of the interaction with the listview must be handled via
  ' the API.  the basic functionality of the listview has been
  ' implemented in this project but many more enhancements are
  ' possible.
  '
  ' this project shows the display of a very large number of items.
  ' it is important to emphasize that displaying large amounts of
  ' data like this is usually a VERY BAD design practice and should
  ' be avoided.  the purpose of this demo is just to show some of
  ' the possibilities that a virtual list opens.
  '
  ' this example project was written using VB5 and the VB5 version
  ' of the listview control.  if you are using VB6, you will need
  ' to change the references to accommodate the VB6 version of the
  ' control.  also, for the VB6 version of the control, you will
  ' need to change the listview class name used in the
  ' VirtualListAppHook proc from "ListViewWndClass" to
  ' "ListView20WndClass" AND, comment out the line of code specified
  ' in the VirtualListOrStyle_WndProc procedure
  '


  Public Const API_FALSE As Long = 0&
  Public Const API_TRUE As Long = 1&
  Public Const MAX_PATH As Long = 260&
  Public Const vbZLString As String = ""
  
  Public Const WS_BORDER As Long = &H800000
  
  Public Const GWL_STYLE As Long = (-16&)
  Public Const GWL_WNDPROC As Long = (-4&)
  
  Public Const WM_CREATE As Long = &H1&

  Public Type CWPSTRUCT
    lParam As Long
    wParam As Long
    message As Long
    hWnd As Long
  End Type

  Public Type CREATESTRUCT
    lpCreateParams As Long
    hInstance As Long
    hMenu As Long
    hWndParent As Long
    cy As Long
    cx As Long
    y As Long
    x As Long
    style As Long
    lpszName As Long    ' String
    lpszClass As Long
    ExStyle As Long
  End Type

  
  Public Const WH_CALLWNDPROC As Long = 4&
  
  Public Declare Function SetWindowsHookEx Lib "user32" Alias "SetWindowsHookExA" (ByVal idHook As Long, ByVal lpfn As Long, ByVal hmod As Long, ByVal dwThreadId As Long) As Long
  Public Declare Function CallNextHookEx Lib "user32" (ByVal hHook As Long, ByVal ncode As Long, ByVal wParam As Long, lParam As Any) As Long
  Public Declare Function UnhookWindowsHookEx Lib "user32" (ByVal hHook As Long) As Long

  Public Type RECT
    Left As Long
    Top As Long
    Right As Long
    Bottom As Long
  End Type

  Public Type POINTAPI
    x As Long
    y As Long
  End Type
  
  Public Type POINTL
    x As Long
    y As Long
  End Type


  Public Declare Function GetClassName Lib "user32" Alias "GetClassNameA" (ByVal hWnd&, ByVal lpClassName$, ByVal nMaxCount&) As Long
  
  Public Declare Function GetWindowRect Lib "user32" (ByVal hWnd&, lpRect As RECT) As Long

  Public Declare Function ScreenToClientLong Lib "user32" Alias "ScreenToClient" (ByVal hWnd&, lpPoint&) As Long

  Public Declare Function GetParent Lib "user32" (ByVal hWnd&) As Long

  Public Declare Function MoveWindow Lib "user32" (ByVal hWnd&, ByVal x&, ByVal y&, ByVal nWidth&, ByVal nHeight&, ByVal bRepaint&) As Long

  Public Declare Function SendMessage Lib "user32" Alias "SendMessageA" (ByVal hWnd&, ByVal wMsg&, wParam As Any, lParam As Any) As Long


  Public Declare Function GetWindowLong Lib "user32" Alias "GetWindowLongA" (ByVal hWnd&, ByVal nIndex&) As Long
                                                                      
  Public Declare Function SetWindowLong Lib "user32" Alias "SetWindowLongA" (ByVal hWnd&, _
                                                              ByVal nIndex&, ByVal dwNewLong&) As Long
  
  Public Declare Function CallWindowProc Lib "user32" Alias "CallWindowProcA" (ByVal lpPrevWndFunc&, _
                                                ByVal hWnd&, ByVal Msg&, ByVal wParam&, ByVal lParam&) As Long

  Public Declare Sub CopyMemory Lib "kernel32" Alias "RtlMoveMemory" (lpDest As Any, lpSource As Any, ByVal cBytes&)

  Public Declare Function SetProp Lib "user32" Alias "SetPropA" (ByVal hWnd&, ByVal lpString$, ByVal hData&) As Long
  Public Declare Function GetProp Lib "user32" Alias "GetPropA" (ByVal hWnd&, ByVal lpString$) As Long
  Public Declare Function RemoveProp Lib "user32" Alias "RemovePropA" (ByVal hWnd&, ByVal lpString$) As Long

  Public Const SM_CYEDGE As Long = 46&

  Public Declare Function GetSystemMetrics Lib "user32" (ByVal nIndex&) As Long


  Public Const WM_TIMER As Long = &H113&

  Public Const WM_LBUTTONDOWN As Long = &H201&
  Public Const WM_RBUTTONDOWN As Long = &H204&
  Public Const WM_MBUTTONDOWN As Long = &H207&
  
  Public Const WM_NOTIFY As Long = &H4E&


  Public Type NMHDR
    hWndFrom As Long   ' Window handle of control sending message
    idFrom As Long        ' Identifier of control sending message
    code  As Long          ' Specifies the notification code
  End Type


  Public Enum LV_ITEM_mask
    LVIF_TEXT = &H1
    LVIF_IMAGE = &H2
    LVIF_PARAM = &H4
    LVIF_STATE = &H8
    LVIF_INDENT = &H10
    LVIF_NORECOMPUTE = &H800
    LVIF_DI_SETITEM = &H1000   ' LV_DISPINFO notification
  End Enum

  Public Enum LV_ITEM_state
    LVIS_FOCUSED = &H1
    LVIS_SELECTED = &H2
    LVIS_CUT = &H4
    LVIS_DROPHILITED = &H8
    LVIS_OVERLAYMASK = &HF00
    LVIS_STATEIMAGEMASK = &HF000
    LVIS_ALL = LVIS_FOCUSED Or LVIS_SELECTED Or LVIS_CUT Or LVIS_DROPHILITED Or LVIS_OVERLAYMASK Or LVIS_STATEIMAGEMASK
  End Enum

  Type LV_ITEM
    mask As LV_ITEM_mask
    iItem As Long
    iSubitem As Long
    State As LV_ITEM_state
    stateMask As Long
    pszText As Long  ' if String, must be pre-allocated
    cchTextMax As Long
    iImage As Long
    lParam As Long
    iIndent As Long   ' 4.70
  End Type

  Type LV_DISPINFO
    hdr As NMHDR
    Item As LV_ITEM
  End Type

  Type NM_LISTVIEW
    hdr As NMHDR
    iItem As Long
    iSubitem As Long
    uNewState As Long
    uOldState As Long
    uChanged As Long
    ptAction As POINTAPI
    lParam As Long
  End Type

  Public Const LVIR_BOUNDS As Long = 0&
  
  Public Enum LISTVIEW_MESSAGES
    LVM_FIRST = &H1000
    LVM_SETITEMCOUNT = (LVM_FIRST + 47)
    
    LVM_GETITEMRECT = (LVM_FIRST + 14)
    LVM_SCROLL = (LVM_FIRST + 20)
    LVM_GETTOPINDEX = (LVM_FIRST + 39)
    
    LVM_HITTEST = (LVM_FIRST + 18)
    LVM_DELETEALLITEMS = (LVM_FIRST + 9)
    LVM_SETEXTENDEDLISTVIEWSTYLE = (LVM_FIRST + 54)
    LVM_GETEXTENDEDLISTVIEWSTYLE = (LVM_FIRST + 55)

'    LVN_FIRST = -100&
'    LVN_GETDISPINFO = (LVN_FIRST - 50)
  End Enum

  Public Enum LVNotifications
    LVN_FIRST = -100&   ' &HFFFFFF9C   ' (0U-100U)
    LVN_LAST = -199&   ' &HFFFFFF39   ' (0U-199U)
                                                                 ' lParam points to:
    LVN_ITEMCHANGING = (LVN_FIRST - 0)             ' NM_LISTVIEW
    LVN_ITEMCHANGED = (LVN_FIRST - 1)              ' NM_LISTVIEW
    LVN_INSERTITEM = (LVN_FIRST - 2)                  ' NM_LISTVIEW
    LVN_DELETEITEM = (LVN_FIRST - 3)                 ' NM_LISTVIEW
    LVN_DELETEALLITEMS = (LVN_FIRST - 4)         ' NM_LISTVIEW
  
    LVN_COLUMNCLICK = (LVN_FIRST - 8)              ' NM_LISTVIEW
    LVN_BEGINDRAG = (LVN_FIRST - 9)                 ' NM_LISTVIEW
    LVN_BEGINRDRAG = (LVN_FIRST - 11)             ' NM_LISTVIEW
    LVN_ODCACHEHINT = (LVN_FIRST - 13)   ' > 4.70
    LVN_ITEMACTIVATE = (LVN_FIRST - 14)
    LVN_ODSTATECHANGED = (LVN_FIRST - 15)
   
    LVN_BEGINLABELEDIT = (LVN_FIRST - 5)        ' LV_DISPINFO
    LVN_ENDLABELEDIT = (LVN_FIRST - 6)           ' LV_DISPINFO
    LVN_GETDISPINFO = (LVN_FIRST - 50)            ' LV_DISPINFO
    LVN_SETDISPINFO = (LVN_FIRST - 51)            ' LV_DISPINFO
    LVN_ODFINDITEM = (LVN_FIRST - 52)
   
    LVN_KEYDOWN = (LVN_FIRST - 55)                 ' LV_KEYDOWN
    LVN_MARQUEEBEGIN = (LVN_FIRST - 56)
  End Enum

  ' // these flags only apply to LVS_OWNERDATA listviews in report or list mode
  Public Enum LVM_SETITEMCOUNT_lParam   ' > 4.70
    LVSICF_NOINVALIDATEALL = &H1
    LVSICF_NOSCROLL = &H2
  End Enum

  Public Enum LVM_SETEXTENDEDLISTVIEWSTYLE_lParam   ' > 4.70
    LVS_EX_GRIDLINES = &H1
    LVS_EX_SUBITEMIMAGES = &H2
    LVS_EX_CHECKBOXES = &H4
    LVS_EX_TRACKSELECT = &H8
    LVS_EX_HEADERDRAGDROP = &H10
    LVS_EX_FULLROWSELECT = &H20         ' // applies to report mode only
    LVS_EX_ONECLICKACTIVATE = &H40
    LVS_EX_TWOCLICKACTIVATE = &H80
  End Enum

  Public Enum LV_HITTESTINFO_flags
    LVHT_NOWHERE = &H1
    LVHT_ONITEMICON = &H2
    LVHT_ONITEMLABEL = &H4
    LVHT_ONITEMSTATEICON = &H8
    LVHT_ONITEM = (LVHT_ONITEMICON Or LVHT_ONITEMLABEL Or LVHT_ONITEMSTATEICON)
   
    LVHT_ABOVE = &H8
    LVHT_BELOW = &H10
    LVHT_TORIGHT = &H20
    LVHT_TOLEFT = &H40
  End Enum

  Type LV_HITTESTINFO
    pt As POINTAPI
    Flags As LV_HITTESTINFO_flags
    iItem As Long
  End Type
 
  Public Enum LVStyles
    LVS_ICON = &H0
    LVS_REPORT = &H1
    LVS_SMALLICON = &H2
    LVS_LIST = &H3
    LVS_TYPEMASK = &H3
    LVS_SINGLESEL = &H4
    LVS_SHOWSELALWAYS = &H8
    LVS_SORTASCENDING = &H10
    LVS_SORTDESCENDING = &H20
    LVS_SHAREIMAGELISTS = &H40
    LVS_NOLABELWRAP = &H80
    LVS_AUTOARRANGE = &H100
    LVS_EDITLABELS = &H200
    LVS_OWNERDATA = &H1000
    LVS_NOSCROLL = &H2000
   
    LVS_TYPESTYLEMASK = &HFC00
   
    LVS_ALIGNTOP = &H0
    LVS_ALIGNLEFT = &H800
    LVS_ALIGNMASK = &HC00
   
    LVS_OWNERDRAWFIXED = &H400
    LVS_NOCOLUMNHEADER = &H4000
    LVS_NOSORTHEADER = &H8000
  End Enum   ' LVStyles
  
  Public Declare Function lstrcpyFromPointer Lib "kernel32" Alias "lstrcpyA" (ByVal lpDest$, ByVal lpSource&) As Long
  Public Declare Function lstrcpyToPointer Lib "kernel32" Alias "lstrcpyA" (ByVal lpDest&, ByVal lpSource$) As Long
  Public Declare Function lstrlenFromPointer Lib "kernel32" Alias "lstrlenA" (ByVal lpString&) As Long
  
  Public Enum TT_Notifications
    TTN_FIRST = -520&   '   (0U-520U)
    TTN_LAST = -549&    '   (0U-549U)
    TTN_GETDISPINFO = (TTN_FIRST - 0)
  End Enum

  Public Type TOOLTIPTEXT
    hdr As NMHDR
    lpszText As Long
    szText As String * 80
    hinst As Long
    uflags As Long
  End Type

