VERSION 5.00
Object = "{6B7E6392-850A-101B-AFC0-4210102A8DA7}#1.3#0"; "COMCTL32.OCX"
Begin VB.UserControl UVirtualListView 
   BackColor       =   &H80000005&
   ClientHeight    =   1260
   ClientLeft      =   0
   ClientTop       =   0
   ClientWidth     =   2010
   ScaleHeight     =   84
   ScaleMode       =   3  'Pixel
   ScaleWidth      =   134
   ToolboxBitmap   =   "UVirtualList.ctx":0000
   Begin ComctlLib.ListView lvVirtual 
      Height          =   1230
      Left            =   15
      TabIndex        =   0
      Top             =   0
      Width           =   1950
      _ExtentX        =   3440
      _ExtentY        =   2170
      View            =   3
      LabelEdit       =   1
      LabelWrap       =   -1  'True
      HideSelection   =   -1  'True
      _Version        =   327682
      ForeColor       =   -2147483640
      BackColor       =   -2147483643
      Appearance      =   1
      NumItems        =   0
   End
End
Attribute VB_Name = "UVirtualListView"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
  Option Explicit
  ' demo project showing how to change styles of a VB listview to
  ' create a fully "vurtual list".  a virtual list is a list that
  ' is displayed by a control but the control itself doesn't contian
  ' or "store" the actual list items.  in other words, each time the
  ' control needs to draw an item, it raises an event to get the text
  ' that it needs to draw.  because the control doesn't need to have
  ' each item loaded "into" it, it can display large numbers of items
  ' blindingly fast.  Parts of this project are based on the code
  ' from the blackbelt article by Matt Hart found in the July, 1999
  ' issue of the VBPJ.  Any and all copyrights of the concept and
  ' code presented by Mr. Hart are still in effect and this demo
  ' makes no claim to the contrary.  this extension of Mr. Hart's
  ' concept is provided by Bryan Stafford of New Vision Software -
  ' newvision@mvps.org this demo is released "as is" without
  ' warranty or guaranty of any kind.  In other words, use at your
  ' own risk.
  '
  ' IMPORTANT NOTE:  this demo uses the 'Dbgwproc.dll' from the MS
  ' VB owner's area to allow breaking while running in the VB IDE.
  ' Although you can run this project without using the debug object,
  ' it is STRONGLY recommended that you use it due to the high
  ' potential for crashing the VB IDE without it.  If you choose to
  ' run this project without the debug object, set the Conditional
  ' Compilation Argument 'DEBUGWINDOWPROC' equal to zero on the Make
  ' tab of the Project Properties dialog.  You will also need to
  ' remove the reference to 'Debug Object for AddressOf Subclassing'
  ' in the references dialog.  !!BE WARNED!! If YOU RUN THIS PROJECT
  ' WITHOUT THE DEBUG OBJECT, YOU WILL MOST LIKELY CRASH YOUR
  ' INSTANCE OF VB!!
  '
  '
  ' ALSO NOTE:  this is a minimal implementation of a virtual
  ' listview.  because all of the items are virtual, the internal
  ' listitems collection of the listview is not used.  this means
  ' most of the interaction with the listview must be handled via
  ' the API.  the basic functionality of the listview has been
  ' implemented in this project but many more enhancements are
  ' possible.
  '
  ' this project shows the display of a very large number of items.
  ' it is important to emphasize that displaying large amounts of
  ' data like this is usually a VERY BAD design practice and should
  ' be avoided.  the purpose of this demo is just to show some of
  ' the possibilities that a virtual list opens.
  '
  ' this example project was written using VB5 and the VB5 version
  ' of the listview control.  if you are using VB6, you will need
  ' to change the references to accommodate the VB6 version of the
  ' control.  also, for the VB6 version of the control, you will
  ' need to change the listview class name used in the
  ' VirtualListAppHook proc from "ListViewWndClass" to
  ' "ListView20WndClass" AND, comment out the line of code specified
  ' in the VirtualListOrStyle_WndProc procedure
  '

  ' used in subclassing the useercontrol
  ' if we are using the debug dll, we need a debug hook variable
  #If DEBUGWINDOWPROC Then
    Private m_ParentDWPHook As WindowProcHook
    Private m_ListViewDWPHook As WindowProcHook
  #End If
  ' original window proc address
  Private m_nParentWinProcOld As Long
  Private m_nLVWindProcOld As Long

  ' flag to tell whether or not we are in design mode
  Private m_fDesign As Boolean
  
  ' the number of items in the list
  Private m_nNumItems As Long

  ' the listbox events
  Event Click()
  Event DblClick()
  Event ItemClick(ByVal nButton&, ByVal nItem&)
  Event ColumnClick(ByVal nColumn&)
  Event BeforeLabelEdit(ByRef Cancel As Boolean, ByVal nItem&)
  Event AfterLabelEdit(ByRef Cancel As Boolean, ByVal sItemText$, ByVal nItem&)
  Event LVDragDrop(Source As Control, x As Single, y As Single)
  Event LVDragOver(Source As Control, x As Single, y As Single, State As Integer)
  Event LVGotFocus()
  Event KeyDown(KeyCode As Integer, Shift As Integer)
  Event KeyPress(KeyAscii As Integer)
  Event KeyUp(KeyCode As Integer, Shift As Integer)
  Event LVLostFocus()
  Event MouseDown(Button As Integer, Shift As Integer, x As Single, y As Single)
  Event MouseMove(Button As Integer, Shift As Integer, x As Single, y As Single)
  Event MouseUp(Button As Integer, Shift As Integer, x As Single, y As Single)
  Event OLECompleteDrag(Effect As Long)
  Event OLEDragDrop(Data As DataObject, Effect As Long, Button As Integer, Shift As Integer, x As Single, y As Single)
  Event OLEDragOver(Data As DataObject, Effect As Long, Button As Integer, Shift As Integer, x As Single, y As Single, State As Integer)
  Event OLEGiveFeedback(Effect As Long, DefaultCursors As Boolean)
  Event OLESetData(Data As DataObject, DataFormat As Integer)
  Event OLEStartDrag(Data As DataObject, AllowedEffects As Long)
  Event Scroll()

  ' custome event to retrieve the item text and desired colors
  Event ItemInfoCallback(ByVal iItem&, ByVal iSubitem&, ByVal fMask&, sText$, hImage&)
  
Friend Function VirtualListProc(ByVal hWnd&, ByVal uMsg&, ByVal wParam&, ByVal lParam&) As Long

  Static x&, y&, nButton&, bMouseDownReceived As Boolean
  
  Dim udtNMHDR As NMHDR, udtNM_LISTVIEW As NM_LISTVIEW, udtLV_DISPINFO As LV_DISPINFO
  Dim nWinProcUse&, bCancel As Boolean
  Dim nStrLen&, sTemp$, hIcon&
  Dim fCancel As Boolean, fFlags&, nItem&
  
  Select Case uMsg
    Case WM_TIMER
      ' because of all of the label editing and drag & drop things going on in a listview,
      ' it doesn't do the normal button up messages that other controls do.  instead, it
      ' sets a timer in the button down message and if the timer times out, we know that
      ' a regular click occured on the item.  the WM_TIMER message is sent when the timer
      ' times out
      If hWnd = lvVirtual.hWnd Then
        If bMouseDownReceived Then
          bMouseDownReceived = False
          
          Me.HitTest x, y, nItem, fFlags
          
          Select Case nButton
            Case WM_LBUTTONDOWN: nButton = 1
            Case WM_RBUTTONDOWN: nButton = 2
            Case WM_MBUTTONDOWN: nButton = 4
          End Select
          
          RaiseEvent ItemClick(nButton, nItem)
        End If
      End If
      
    Case WM_LBUTTONDOWN, WM_MBUTTONDOWN, WM_RBUTTONDOWN
      ' cache the values in the mouse down for use in the WM_TIMER handler above
      bMouseDownReceived = True
      
      x = LOWORD(lParam)
      y = HIWORD(lParam)
      
      nButton = uMsg


    Case WM_NOTIFY
      ' IMPORTANT!!!  Do NOT set breakpoints in any of the WM_NOTIFY message handlers or the
      ' events raised by them.
      
      CopyMemory udtNMHDR, ByVal lParam, LenB(udtNMHDR)
      
      With udtNMHDR
        ' for the VB6 version of the listview, we need to handle the TTN_GETDISPINFO message or the control will crash
        If .code = TTN_GETDISPINFO Then
          ' return 1 to indicate we have handled the message and then exit the function
          VirtualListProc = 1

          Exit Function
        End If
        
        
        Select Case .hWndFrom
          Case lvVirtual.hWnd
          
            Select Case .code
              Case LVN_COLUMNCLICK, LVN_ITEMCHANGING
                CopyMemory udtNM_LISTVIEW, ByVal lParam, LenB(udtNM_LISTVIEW)
              Case LVN_BEGINLABELEDIT, LVN_ENDLABELEDIT, LVN_GETDISPINFO
                CopyMemory udtLV_DISPINFO, ByVal lParam, LenB(udtLV_DISPINFO)
            End Select

            Select Case .code
              Case LVN_BEGINLABELEDIT
                RaiseEvent BeforeLabelEdit(bCancel, udtLV_DISPINFO.Item.iItem)
                
                If bCancel Then
                  VirtualListProc = API_TRUE
                  Exit Function
                End If
                
                
              Case LVN_ENDLABELEDIT
                If udtLV_DISPINFO.Item.pszText Then
                  nStrLen = lstrlenFromPointer(udtLV_DISPINFO.Item.pszText)
                  sTemp = String$(nStrLen, vbNullChar)
                  Call lstrcpyFromPointer(sTemp, udtLV_DISPINFO.Item.pszText)
                  
                  RaiseEvent AfterLabelEdit(bCancel, sTemp, udtLV_DISPINFO.Item.iItem)
                
                  If bCancel = False Then
                    VirtualListProc = API_TRUE
                    Exit Function
                  End If
                End If
          
              
              Case LVN_COLUMNCLICK
                RaiseEvent ColumnClick(udtNM_LISTVIEW.iSubitem)
              
              
              Case LVN_GETDISPINFO
                ' this is the message passed when the listview needs the text for an item or subitem
                RaiseEvent ItemInfoCallback(udtLV_DISPINFO.Item.iItem, udtLV_DISPINFO.Item.iSubitem, _
                                                                        udtLV_DISPINFO.Item.mask, sTemp, hIcon)
          
                If udtLV_DISPINFO.Item.mask And LVIF_TEXT Then
                  If Len(sTemp) > udtLV_DISPINFO.Item.cchTextMax Then sTemp = Left$(sTemp, udtLV_DISPINFO.Item.cchTextMax)
          
                  lstrcpyToPointer udtLV_DISPINFO.Item.pszText, sTemp
                  udtLV_DISPINFO.Item.iImage = hIcon
          
                  CopyMemory ByVal lParam, udtLV_DISPINFO, LenB(udtLV_DISPINFO)
                End If

                
            End Select
            
            Exit Function
                      
        End Select
        
      End With
      
  End Select
  

  Select Case hWnd
    Case lvVirtual.hWnd: nWinProcUse = m_nLVWindProcOld
    Case UserControl.hWnd: nWinProcUse = m_nParentWinProcOld
  End Select
  
  If nWinProcUse Then VirtualListProc = CallWindowProc(nWinProcUse, hWnd, uMsg, wParam, lParam)
  
End Function

Public Sub Refresh()
  UserControl.Refresh
  lvVirtual.Refresh
End Sub

Private Sub UserControl_AmbientChanged(PropertyName As String)
  If m_fDesign Then
    If PropertyName = "DisplayName" Then SetDisplayName
  End If
End Sub

Private Sub SetDisplayName()
  ' when in design mode, add the display name to the list
  lvVirtual.Visible = False
  With UserControl
    .AutoRedraw = True
    .BorderStyle = 1
    UserControl.Print .Ambient.DisplayName
  End With
End Sub

Private Sub UserControl_EnterFocus()
  lvVirtual.SetFocus
End Sub

Private Sub UserControl_Resize()
  ' resize the listbox with the usercontrol
    
  With UserControl
    lvVirtual.Move 0, 0, .ScaleWidth, .ScaleHeight
    
    
    ' if you have the IntegralHeight property for the listbox set to True,
    ' we need to handle adjusting the height of the usercontrol to match the listbox
    If .ScaleHeight <> lvVirtual.Height Then
      Dim rc As RECT
      
      Call GetWindowRect(.hWnd, rc)
      
      Call ScreenToClientLong(GetParent(.hWnd), rc.Left)
      Call ScreenToClientLong(GetParent(.hWnd), rc.Right)
      
      With rc
        .Right = .Right - .Left
        .Bottom = .Top + (lvVirtual.Height - GetSystemMetrics(SM_CYEDGE))
      End With
      
      Call MoveWindow(.hWnd, rc.Left, rc.Top, rc.Right, rc.Bottom, API_TRUE)
    End If
  End With
  
End Sub

Private Sub InitializeList()
  Static bListCreated As Boolean
  
  If bListCreated = False Then
    bListCreated = True
    
    SubClass
  End If
  
End Sub

Private Sub UserControl_Initialize()
  ' set the hook when we are not in design mode
  If g_bNotDesignMode Then MVirtualListView.SetVirtualListHook
End Sub

Private Sub UserControl_Terminate()
  ' make sure we un subclass the usercontrol so we don't crash
  UnSubClass
End Sub

Private Sub UserControl_InitProperties()
  
  SetDesignMode
  
  If Not m_fDesign Then
    InitializeList
  Else
    SetDisplayName
  End If
  
End Sub

Private Sub UserControl_ReadProperties(PropBag As PropertyBag)
  ' any properties that can be saved need to be retrieved and set here
  Set lvVirtual.Font = PropBag.ReadProperty("Font", Ambient.Font)
  Set UserControl.Font = lvVirtual.Font
  lvVirtual.BackColor = PropBag.ReadProperty("BackColor", vbWindowBackground)
  lvVirtual.ForeColor = PropBag.ReadProperty("ForeColor", vbWindowText)

  
  SetDesignMode
  
  If Not m_fDesign Then
    InitializeList
  Else
    SetDisplayName
  End If

End Sub

Private Sub UserControl_WriteProperties(PropBag As PropertyBag)
  ' write any properties that need to be saved here
  PropBag.WriteProperty "Font", lvVirtual.Font, Ambient.Font
  PropBag.WriteProperty "BackColor", lvVirtual.BackColor, vbWindowBackground
  PropBag.WriteProperty "ForeColor", lvVirtual.ForeColor, vbWindowText
End Sub

Private Sub NoPropertySheet()
  ' allows us to hide runtime only properties from the property sheet in the IDE

  ' if you stop on this error, right click on the code window and choose
  ' "Toggle/Break on Unhandled Errors" to continue
  If m_fDesign Then Err.Raise 394 '<-- GetNotSupported
End Sub

Private Sub DesignTimeOnly()
  ' if we don't want to allow access to a property at runtime,
  ' add this line to the property Let, Set or Get
  If Not m_fDesign Then Err.Raise 382
End Sub

Private Sub SetDesignMode()
  On Error Resume Next
  m_fDesign = Not Ambient.UserMode
  If Err Then m_fDesign = True
  Err.Clear
End Sub

Public Sub SubClass()
  ' this routine subclasses the window

  UnSubClass
  
  ' we store a pointer to this instance of the class in an extra property
  ' we add to the window using the SetProp API function.  if the property exists,
  ' this window is already subclassed and we don't want to overwrite the property
  If GetProp(UserControl.hWnd, "nvVirtualLV") Then Exit Sub
  
  ' store a pointer to this instance of the class object in an added property
  If SetProp(UserControl.hWnd, ByVal "nvVirtualLV", ObjPtr(Me)) Then
    ' if the SetProp call succeeded, subclass the window...
    
    If SetProp(lvVirtual.hWnd, ByVal "nvVirtualLV", ObjPtr(Me)) Then
      
      ' we use a conditional compilation argument to tell whether or not we should use the
      ' debug dll.  when you want to compile a release, set the DEBUGWINDOWPROC variable in
      ' the project properties dialog to zero.
      #If DEBUGWINDOWPROC Then
        ' this is the procedure for setting a debug hook...
        Set m_ParentDWPHook = CreateWindowProcHook
        With m_ParentDWPHook
        
          ' our windowproc is in the MAdvancedSubclass BAS module
          .SetMainProc AddressOf MVirtualListView.VirtualListProc
          
          ' replace the windowproc for this window with ours
          m_nParentWinProcOld = SetWindowLong(UserControl.hWnd, GWL_WNDPROC, .ProcAddress)
          .SetDebugProc m_nParentWinProcOld
        End With
        
        
        Set m_ListViewDWPHook = CreateWindowProcHook
        With m_ListViewDWPHook
        
          ' our windowproc is in the MAdvancedSubclass BAS module
          .SetMainProc AddressOf MVirtualListView.VirtualListProc
          
          ' replace the windowproc for this window with ours
          m_nLVWindProcOld = SetWindowLong(lvVirtual.hWnd, GWL_WNDPROC, .ProcAddress)
          .SetDebugProc m_nLVWindProcOld
        End With
      #Else
        ' not using the debug dll so just replace the windowproc for this window with ours.
        ' our windowproc is in the MAdvancedSubclass BAS module
        m_nParentWinProcOld = SetWindowLong(UserControl.hWnd, GWL_WNDPROC, AddressOf MVirtualListView.VirtualListProc)
        m_nLVWindProcOld = SetWindowLong(lvVirtual.hWnd, GWL_WNDPROC, AddressOf MVirtualListView.VirtualListProc)
      #End If
  
    End If
  End If
  
End Sub

Private Sub UnSubClass()
  ' this routine un-subclasses the window
    
  ' if we have an address for the old windowproc, return the proc to the original state...
  If m_nLVWindProcOld Then
    ' un-subclass the window
    SetWindowLong lvVirtual.hWnd, GWL_WNDPROC, m_nLVWindProcOld
    
    ' remove the added property
    RemoveProp lvVirtual.hWnd, "nvVirtualLV"
    
    ' set the variables to zero to avoid any misshaps
    m_nLVWindProcOld = 0
  End If
  
  ' if we are using the debug dll, destroy the instance
  #If DEBUGWINDOWPROC Then
    Set m_ListViewDWPHook = Nothing
  #End If



  ' if we have an address for the old windowproc, return the proc to the original state...
  If m_nParentWinProcOld Then
    ' un-subclass the window
    SetWindowLong UserControl.hWnd, GWL_WNDPROC, m_nParentWinProcOld
    
    ' remove the added property
    RemoveProp UserControl.hWnd, "nvVirtualLV"
    
    ' set the variables to zero to avoid any misshaps
    m_nParentWinProcOld = 0
  End If
  
  ' if we are using the debug dll, destroy the instance
  #If DEBUGWINDOWPROC Then
    Set m_ParentDWPHook = Nothing
  #End If
  
End Sub


' #############  Begin Properties and Methods  ##############
Public Sub SetItemCount(ByVal nItems&)
  Call CallWindowProc(m_nLVWindProcOld, lvVirtual.hWnd, LVM_SETITEMCOUNT, nItems, LVSICF_NOINVALIDATEALL)
  m_nNumItems = nItems
End Sub

Public Property Get BackColor() As OLE_COLOR
  BackColor = lvVirtual.BackColor
End Property
Public Property Let BackColor(ByVal nNewVal As OLE_COLOR)
  lvVirtual.BackColor = nNewVal
  PropertyChanged "BackColor"
End Property

Public Sub Clear()
  Call CallWindowProc(m_nLVWindProcOld, lvVirtual.hWnd, LVM_SETITEMCOUNT, 0&, LVSICF_NOINVALIDATEALL)
  lvVirtual.Refresh
  m_nNumItems = 0
End Sub

Public Property Get Font() As StdFont
  Set Font = lvVirtual.Font
End Property
Public Property Set Font(ByVal oNewVal As StdFont)
  Set lvVirtual.Font = oNewVal
  PropertyChanged "Font"
End Property

Public Property Get FontBold() As Boolean
  NoPropertySheet
  FontBold = lvVirtual.Font.Bold
End Property
Public Property Let FontBold(ByVal bNewVal As Boolean)
  NoPropertySheet
  lvVirtual.Font.Bold = bNewVal
End Property

Public Property Get FontItalic() As Boolean
  NoPropertySheet
  FontItalic = lvVirtual.Font.Italic
End Property
Public Property Let FontItalic(ByVal bNewVal As Boolean)
  NoPropertySheet
  lvVirtual.Font.Italic = bNewVal
End Property

Public Property Get FontName(ByVal Index%) As String
  NoPropertySheet
  FontName = lvVirtual.Font.Name
End Property
Public Property Let FontName(ByVal Index%, ByVal sNewVal$)
  NoPropertySheet
  lvVirtual.Font.Name = sNewVal
End Property

Public Property Get FontSize() As Single
  NoPropertySheet
  FontSize = lvVirtual.Font.Size
End Property
Public Property Let FontSize(ByVal sngNewVal!)
  NoPropertySheet
  lvVirtual.Font.Size = sngNewVal
End Property

Public Property Get FontStrikethru() As Boolean
  NoPropertySheet
  FontStrikethru = lvVirtual.Font.Strikethru
End Property
Public Property Let FontStrikethru(ByVal bNewVal As Boolean)
  NoPropertySheet
  lvVirtual.Font.Strikethru = bNewVal
End Property

Public Property Get FontUnderline() As Boolean
  NoPropertySheet
  FontUnderline = lvVirtual.Font.Underline
End Property
Public Property Let FontUnderline(ByVal bNewVal As Boolean)
  NoPropertySheet
  lvVirtual.Font.Underline = bNewVal
End Property

Public Property Get ForeColor() As OLE_COLOR
  ForeColor = lvVirtual.ForeColor
End Property
Public Property Let ForeColor(ByVal nNewVal As OLE_COLOR)
  lvVirtual.ForeColor = nNewVal
  PropertyChanged "ForeColor"
End Property

Public Property Get HelpContextID() As Long
  HelpContextID = lvVirtual.HelpContextID
End Property
Public Property Let HelpContextID(ByVal nNewVal&)
  lvVirtual.HelpContextID = nNewVal
End Property

Public Property Get UChWnd() As Long
  UChWnd = UserControl.hWnd
End Property

Public Property Get hWnd() As Long
  hWnd = lvVirtual.hWnd
End Property

Public Property Get ListCount() As Integer
  NoPropertySheet
  ListCount = m_nNumItems
End Property

Public Property Get MouseIcon() As StdPicture
  Set MouseIcon = lvVirtual.MouseIcon
End Property
Public Property Let MouseIcon(ByVal oNewVal As StdPicture)
  lvVirtual.MouseIcon = oNewVal
End Property

Public Property Get MousePointer() As Integer
  MousePointer = lvVirtual.MousePointer
End Property
Public Property Let MousePointer(ByVal nNewVal%)
  lvVirtual.MousePointer = nNewVal
End Property

Public Sub OLEDrag()
  lvVirtual.OLEDrag
End Sub

Public Property Get OLEDragMode() As Integer
  OLEDragMode = lvVirtual.OLEDragMode
End Property
Public Property Let OLEDragMode(ByVal nNewVal%)
  lvVirtual.OLEDragMode = nNewVal
End Property

Public Property Get OLEDropMode() As Integer
  OLEDropMode = lvVirtual.OLEDropMode
End Property
Public Property Let OLEDropMode(ByVal nNewVal%)
  lvVirtual.OLEDropMode = nNewVal
End Property

Public Sub ShowWhatsThis()
  lvVirtual.ShowWhatsThis
End Sub

Public Property Get Sorted() As Boolean
  Sorted = lvVirtual.Sorted
End Property

Public Property Get TOOLTIPTEXT() As String
  TOOLTIPTEXT = lvVirtual.TOOLTIPTEXT
End Property
Public Property Let TOOLTIPTEXT(ByVal sNewVal$)
  lvVirtual.TOOLTIPTEXT = sNewVal
End Property

Public Property Get WhatsThisHelpID() As Long
  WhatsThisHelpID = lvVirtual.WhatsThisHelpID
End Property
Public Property Let WhatsThisHelpID(ByVal nNewVal&)
  lvVirtual.WhatsThisHelpID = nNewVal
End Property

Public Sub HitTest(x&, y&, iItem&, fFlags&)
  
  Dim udtLV_HITTESTINFO As LV_HITTESTINFO
  
  udtLV_HITTESTINFO.pt.x = x
  udtLV_HITTESTINFO.pt.y = y
  
  If CallWindowProc(m_nLVWindProcOld, lvVirtual.hWnd, LVM_HITTEST, API_FALSE, VarPtr(udtLV_HITTESTINFO)) <> (-1) Then
    With udtLV_HITTESTINFO
      fFlags = .Flags
      iItem = .iItem
    End With
  End If
      
End Sub

Public Property Get ColumnHeaders() As ComctlLib.ColumnHeaders
  Set ColumnHeaders = lvVirtual.ColumnHeaders
End Property

Public Property Get FullRowSelect() As Boolean
  If Not m_fDesign Then
    If CallWindowProc(m_nLVWindProcOld, lvVirtual.hWnd, LVM_GETEXTENDEDLISTVIEWSTYLE, 0&, 0&) And LVS_EX_FULLROWSELECT Then
      FullRowSelect = True
    End If
  End If
End Property
Public Property Let FullRowSelect(ByVal vNewValue As Boolean)
  Dim nSetValue&, bChangeStyle As Boolean, fCurStyle&
  
  nSetValue = CallWindowProc(m_nLVWindProcOld, lvVirtual.hWnd, LVM_GETEXTENDEDLISTVIEWSTYLE, 0&, 0&)
  
  fCurStyle = (nSetValue And LVS_EX_FULLROWSELECT) <> 0
  
  If (vNewValue = True) And (fCurStyle = False) Then
    'set the extended style bit
    nSetValue = nSetValue Or LVS_EX_FULLROWSELECT
    bChangeStyle = True
  ElseIf (vNewValue = False) And (fCurStyle = True) Then
    'remove the extended style bit
    nSetValue = nSetValue Xor LVS_EX_FULLROWSELECT
    bChangeStyle = True
  End If
  
  If bChangeStyle Then
    Call CallWindowProc(m_nLVWindProcOld, lvVirtual.hWnd, LVM_SETEXTENDEDLISTVIEWSTYLE, 0&, nSetValue)
  End If
  
End Property

Public Property Get ShowGridLines() As Boolean
  If Not m_fDesign Then
    If CallWindowProc(m_nLVWindProcOld, lvVirtual.hWnd, LVM_GETEXTENDEDLISTVIEWSTYLE, 0&, 0&) And LVS_EX_GRIDLINES Then
      ShowGridLines = True
    End If
  End If
End Property
Public Property Let ShowGridLines(ByVal vNewValue As Boolean)
  Dim nSetValue&, bChangeStyle As Boolean, fCurStyle&
  
  nSetValue = CallWindowProc(m_nLVWindProcOld, lvVirtual.hWnd, LVM_GETEXTENDEDLISTVIEWSTYLE, 0&, 0&)
  
  fCurStyle = nSetValue And LVS_EX_GRIDLINES
  
  If (vNewValue = True) And (fCurStyle = False) Then
    'set the extended style bit
    nSetValue = nSetValue Or LVS_EX_GRIDLINES
    bChangeStyle = True
  ElseIf (vNewValue = False) And (fCurStyle = True) Then
    'remove the extended style bit
    nSetValue = nSetValue Xor LVS_EX_GRIDLINES
    bChangeStyle = True
  End If
  
  If bChangeStyle Then Call CallWindowProc(m_nLVWindProcOld, lvVirtual.hWnd, LVM_SETEXTENDEDLISTVIEWSTYLE, 0&, nSetValue)
End Property


' #############  Begin Events ###########################

Private Sub lvVirtual_AfterLabelEdit(Cancel As Integer, NewString As String)
  ' not implemented since we are not using the internal listitems collection
End Sub

Private Sub lvVirtual_BeforeLabelEdit(Cancel As Integer)
  ' not implemented since we are not using the internal listitems collection
End Sub

Private Sub lvVirtual_ItemClick(ByVal Item As ComctlLib.ListItem)
  ' not implemented since we are not using the internal listitems collection
End Sub

Private Sub lvVirtual_ColumnClick(ByVal ColumnHeader As ComctlLib.ColumnHeader)
  ' not implemented since we are not using the internal listitems collection
End Sub

Private Sub lvVirtual_Click()
  RaiseEvent Click
End Sub

Private Sub lvVirtual_DblClick()
  RaiseEvent DblClick
End Sub

Private Sub lvVirtual_DragDrop(Source As Control, x As Single, y As Single)
  RaiseEvent LVDragDrop(Source, x, y)
End Sub

Private Sub lvVirtual_DragOver(Source As Control, x As Single, y As Single, State As Integer)
  RaiseEvent LVDragOver(Source, x, y, State)
End Sub

Private Sub lvVirtual_GotFocus()
  RaiseEvent LVGotFocus
End Sub

Private Sub lvVirtual_KeyDown(KeyCode As Integer, Shift As Integer)
  RaiseEvent KeyDown(KeyCode, Shift)
End Sub

Private Sub lvVirtual_KeyPress(KeyAscii As Integer)
  RaiseEvent KeyPress(KeyAscii)
End Sub

Private Sub lvVirtual_KeyUp(KeyCode As Integer, Shift As Integer)
  RaiseEvent KeyUp(KeyCode, Shift)
End Sub

Private Sub lvVirtual_LostFocus()
  RaiseEvent LVLostFocus
End Sub

Private Sub lvVirtual_MouseDown(Button As Integer, Shift As Integer, x As Single, y As Single)
  RaiseEvent MouseDown(Button, Shift, x, y)
End Sub

Private Sub lvVirtual_MouseMove(Button As Integer, Shift As Integer, x As Single, y As Single)
  RaiseEvent MouseMove(Button, Shift, x, y)
End Sub

Private Sub lvVirtual_MouseUp(Button As Integer, Shift As Integer, x As Single, y As Single)
  RaiseEvent MouseUp(Button, Shift, x, y)
End Sub

Private Sub lvVirtual_OLECompleteDrag(Effect As Long)
  RaiseEvent OLECompleteDrag(Effect)
End Sub

Private Sub lvVirtual_OLEDragDrop(Data As ComctlLib.DataObject, Effect As Long, Button As Integer, Shift As Integer, x As Single, y As Single)
  RaiseEvent OLEDragDrop(Data, Effect, Button, Shift, x, y)
End Sub

Private Sub lvVirtual_OLEDragOver(Data As ComctlLib.DataObject, Effect As Long, Button As Integer, Shift As Integer, x As Single, y As Single, State As Integer)
  RaiseEvent OLEDragOver(Data, Effect, Button, Shift, x, y, State)
End Sub

Private Sub lvVirtual_OLEGiveFeedback(Effect As Long, DefaultCursors As Boolean)
  RaiseEvent OLEGiveFeedback(Effect, DefaultCursors)
End Sub

Private Sub lvVirtual_OLESetData(Data As ComctlLib.DataObject, DataFormat As Integer)
  RaiseEvent OLESetData(Data, DataFormat)
End Sub

Private Sub lvVirtual_OLEStartDrag(Data As ComctlLib.DataObject, AllowedEffects As Long)
  RaiseEvent OLEStartDrag(Data, AllowedEffects)
End Sub

Private Sub lvVirtual_Scroll()
  ' not implemented since we are not using the internal listitems collection
End Sub

Public Property Get TopIndex() As Long
  
  TopIndex = CallWindowProc(m_nLVWindProcOld, lvVirtual.hWnd, LVM_GETTOPINDEX, 0&, 0&)
  
End Property

Public Property Let TopIndex(ByVal nNewIndex&)

  Dim lpRect As RECT, nTopIndex&, nItemHeight&, nScroll&

  lpRect.Left = LVIR_BOUNDS
  
  Call CallWindowProc(m_nLVWindProcOld, lvVirtual.hWnd, LVM_GETITEMRECT, 0&, VarPtr(lpRect))

  nItemHeight = lpRect.Bottom - lpRect.Top

  nTopIndex = TopIndex

  If nNewIndex > nTopIndex Then
    nScroll = (nNewIndex - nTopIndex) * nItemHeight
  ElseIf nNewIndex < nTopIndex Then
    nScroll = -((nTopIndex - nNewIndex) * nItemHeight)
  End If

  Call CallWindowProc(m_nLVWindProcOld, lvVirtual.hWnd, LVM_SCROLL, 0&, nScroll)
  
End Property

