VERSION 5.00
Begin VB.Form frmTestVirtualList 
   AutoRedraw      =   -1  'True
   BorderStyle     =   4  'Fixed ToolWindow
   Caption         =   "Virtual ListView"
   ClientHeight    =   3570
   ClientLeft      =   2115
   ClientTop       =   1560
   ClientWidth     =   5535
   Icon            =   "frmTestVirtualList.frx":0000
   LinkTopic       =   "Form1"
   MaxButton       =   0   'False
   MinButton       =   0   'False
   OLEDropMode     =   1  'Manual
   ScaleHeight     =   238
   ScaleMode       =   3  'Pixel
   ScaleWidth      =   369
   Begin VB.CommandButton Command2 
      Caption         =   "Set Topindex"
      Height          =   495
      Left            =   1485
      TabIndex        =   2
      Top             =   2925
      Width           =   1215
   End
   Begin VB.CommandButton Command1 
      Caption         =   "Get Topindex"
      Height          =   495
      Left            =   75
      TabIndex        =   1
      Top             =   2910
      Width           =   1215
   End
   Begin PVirtualListView.UVirtualListView UVirtualListView1 
      Height          =   2760
      Left            =   45
      TabIndex        =   0
      Top             =   30
      Width           =   5445
      _ExtentX        =   9604
      _ExtentY        =   4868
      BeginProperty Font {0BE35203-8F91-11CE-9DE3-00AA004BB851} 
         Name            =   "MS Sans Serif"
         Size            =   8.25
         Charset         =   0
         Weight          =   400
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
   End
End
Attribute VB_Name = "frmTestVirtualList"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
  Option Explicit
  Dim item1(999999) As String
  Dim item2(999999) As String
  Dim item3(999999) As String
  Dim i As Currency
  
  ' demo project showing how to change styles of a VB listview to
  ' create a fully "vurtual list".  a virtual list is a list that
  ' is displayed by a control but the control itself doesn't contian
  ' or "store" the actual list items.  in other words, each time the
  ' control needs to draw an item, it raises an event to get the text
  ' that it needs to draw.  because the control doesn't need to have
  ' each item loaded "into" it, it can display large numbers of items
  ' blindingly fast.  Parts of this project are based on the code
  ' from the blackbelt article by Matt Hart found in the July, 1999
  ' issue of the VBPJ.  Any and all copyrights of the concept and
  ' code presented by Mr. Hart are still in effect and this demo
  ' makes no claim to the contrary.  this extension of Mr. Hart's
  ' concept is provided by Bryan Stafford of New Vision Software -
  ' newvision@mvps.org this demo is released "as is" without
  ' warranty or guaranty of any kind.  In other words, use at your
  ' own risk.
  '
  ' IMPORTANT NOTE:  this demo uses the 'Dbgwproc.dll' from the MS
  ' VB owner's area to allow breaking while running in the VB IDE.
  ' Although you can run this project without using the debug object,
  ' it is STRONGLY recommended that you use it due to the high
  ' potential for crashing the VB IDE without it.  If you choose to
  ' run this project without the debug object, set the Conditional
  ' Compilation Argument 'DEBUGWINDOWPROC' equal to zero on the Make
  ' tab of the Project Properties dialog.  You will also need to
  ' remove the reference to 'Debug Object for AddressOf Subclassing'
  ' in the references dialog.  !!BE WARNED!! If YOU RUN THIS PROJECT
  ' WITHOUT THE DEBUG OBJECT, YOU WILL MOST LIKELY CRASH YOUR
  ' INSTANCE OF VB!!
  '
  '
  ' ALSO NOTE:  this is a minimal implementation of a virtual
  ' listview.  because all of the items are virtual, the internal
  ' listitems collection of the listview is not used.  this means
  ' most of the interaction with the listview must be handled via
  ' the API.  the basic functionality of the listview has been
  ' implemented in this project but many more enhancements are
  ' possible.
  '
  ' this project shows the display of a very large number of items.
  ' it is important to emphasize that displaying large amounts of
  ' data like this is usually a VERY BAD design practice and should
  ' be avoided.  the purpose of this demo is just to show some of
  ' the possibilities that a virtual list opens.
  '
  ' this example project was written using VB5 and the VB5 version
  ' of the listview control.  if you are using VB6, you will need
  ' to change the references to accommodate the VB6 version of the
  ' control.  also, for the VB6 version of the control, you will
  ' need to change the listview class name used in the
  ' VirtualListAppHook proc from "ListViewWndClass" to
  ' "ListView20WndClass" AND, comment out the line of code specified
  ' in the VirtualListOrStyle_WndProc procedure
  '

Private Sub Command1_Click()
  Debug.Print UVirtualListView1.TopIndex
End Sub

Private Sub Command2_Click()
  UVirtualListView1.TopIndex = 100
End Sub

Private Sub Form_Initialize()
  ' used to keep us from crashing in the IDE.  we set this flag so that the user
  ' control will know that the form has actually been loaded and is not in design mode
  g_bNotDesignMode = True
End Sub

Private Sub Form_Load()
For i = 0 To 999999
item1(i) = "item_" & i + 1
item2(i) = "sub1_" & i + 1
item3(i) = "sub2_" & i + 1
Next

  ' set up the listview
  With UVirtualListView1
    ' add some columns
    With .ColumnHeaders
      .Add , , "Item #", 100
      .Add , , "Subitem", 75
      .Add , , "Subitem", 75
    End With
    
    .FullRowSelect = True
    .ShowGridLines = True
    
    ' add over ONE MILLION items!  all items are allocated using a single call!
    .SetItemCount UBound(item1)
  End With
  
End Sub

Private Sub UVirtualListView1_ItemInfoCallback(ByVal iItem As Long, ByVal iSubitem As Long, ByVal fMask As Long, sText As String, hImage As Long)
  ' this is how the virtual list is implemented.  when the listview
  ' needs to draw an item, it raises this event passing a ByRef variable
  ' which we fill with the text that will be displayed for the item at
  ' the index contained in the "iItem" and "iSubitem" params.  if you were
  ' working in an actual application, you would pass the string from a
  ' recordset or an array or some other local stroage scheme.
Dim j As Integer
  
  Select Case iSubitem
    Case 0: sText = item1(iItem)
    Case 1: sText = item2(iItem)
    Case 2: sText = item3(iItem)
  End Select
  
End Sub
